/*
-- Differences with Spagic 2.0.0 --

-- Solve SPAGIC-153 BUGS
-- IF USING SPAGIC 2.0 spagic-mysql-oracle.ddl
-- IN SPAGIC 2.1 THIS IS NOT REQUIRED
*/
ALTER TABLE process modify process_version varchar(20);

ALTER TABLE property MODIFY code varchar(200);

/* -- Differences with Spagic 2.1.0 -- */

ALTER TABLE transition_instance ADD COLUMN attachment_in int DEFAULT 0 AFTER transition_data;

ALTER TABLE transition_instance ADD COLUMN attachment_out int DEFAULT 0 AFTER attachment_in;

ALTER TABLE transition_instance MODIFY TRANSITION_DATA MEDIUMBLOB;

ALTER TABLE transition_instance ADD COLUMN transition_data_out MEDIUMBLOB AFTER TRANSITION_DATA;

ALTER TABLE process ADD COLUMN monitor_enabled BOOLEAN NOT NULL DEFAULT true AFTER state;

/* -- Tables for event handling -- */
Create table wait_data (
	id_wait Bigint(20) NOT NULL AUTO_INCREMENT,
	id_correlation Varchar(200) NOT NULL,
	wait_timestamp Timestamp NOT NULL,
	expiry_timestamp Timestamp NULL DEFAULT NULL,
	expiration_action Varchar(500),
	eventType Varchar(200) NOT NULL DEFAULT "GenericEvent",
	exchange Blob,
	signalUri Varchar(500),
	destinationUri Varchar(500),
 Primary Key (id_wait)) ENGINE = InnoDB;

Create table wait_data_attribute (
	id_wait_data_attribute Bigint NOT NULL AUTO_INCREMENT,
	id_wait Bigint NOT NULL,
	name Varchar(200) NOT NULL,
	att_value Varchar(500),
 Primary Key (id_wait_data_attribute)) ENGINE = InnoDB;

CREATE VIEW bc_input_messages AS
  SELECT s.id_step AS id_binding_component, COUNT(logJournal.id_log) AS input_messages 
	FROM step s, process p, transition_instance t, log_journal logJournal,property_step propertyStep, property pty  	
	WHERE s.id_process = p.id_process AND s.id_process = (SELECT max(pSub.id_process) AS idProcess FROM process pSub WHERE pSub.name=p.name)				
				AND s.id_step = t.id_step_source
				AND t.id_journal = logJournal.id_journal 				
				AND s.id_step=propertyStep.id_step 				
				AND propertyStep.id_property=pty.id_property
				AND pty.code='im.servicebindingname'
				AND ((s.is_start = 1 AND logJournal.id_state IN (0, 3)) 
						OR (pty.value IN ('JBI-WebServicePipeline','JBI-TCPIP-Pipeline','JBI-CXF-Pipeline') AND logJournal.id_state=3 )
						) 				
	group by s.id_step;

CREATE VIEW bc_output_messages AS
  SELECT s.id_step AS id_binding_component, COUNT(logJournal.id_log) AS output_messages 
	FROM step s, process p, transition_instance t, log_journal logJournal,property_step propertyStep, property pty  	
	WHERE s.id_process = p.id_process AND s.id_process = (SELECT max(pSub.id_process) AS idProcess FROM process pSub WHERE pSub.name=p.name)								
				AND t.id_journal = logJournal.id_journal 				
				AND s.id_step=propertyStep.id_step 				
				AND propertyStep.id_property=pty.id_property
				AND pty.code='im.servicebindingname'
				AND ((s.is_end = 1 AND logJournal.id_state=1 AND s.id_step = t.id_step_target)
						OR (pty.value IN ('JBI-WebServicePipeline','JBI-TCPIP-Pipeline','JBI-CXF-Pipeline') AND s.id_step = t.id_step_source AND logJournal.id_state=4 )
            OR (s.is_start = 1 AND logJournal.id_state = 4 AND s.id_step = t.id_step_source)						
						) 				
	group by s.id_step;
	
CREATE VIEW bc_error_messages AS
  SELECT s.id_step AS id_binding_component, COUNT(logJournal.id_log) AS error_messages 
	FROM step s, process p, transition_instance t, log_journal logJournal,property_step propertyStep, property pty  	
	WHERE s.id_process = p.id_process AND s.id_process = (SELECT max(pSub.id_process) AS idProcess FROM process pSub WHERE pSub.name=p.name)								
				AND t.id_journal = logJournal.id_journal 				
				AND s.id_step=propertyStep.id_step 				
				AND propertyStep.id_property=pty.id_property
				AND pty.code='im.servicebindingname'
				AND ((s.is_start = 1 AND s.id_step = t.id_step_source AND logJournal.id_state IN (2, 5))
						OR(s.is_end = 1 AND s.id_step = t.id_step_target AND logJournal.id_state IN (2, 5))
						OR (pty.value IN ('JBI-WebServicePipeline','JBI-TCPIP-Pipeline','JBI-CXF-Pipeline') AND logJournal.id_state=5
								AND (s.id_step = t.id_step_target OR s.id_step = t.id_step_source))
						) 				
	group by s.id_step;
	
ALTER TABLE wait_data_attribute add Foreign Key (id_wait) references wait_data (id_wait) on delete  restrict on update  restrict;

/* -- Exceution Time ( AZ 09/07/2008 ) */
ALTER TABLE transition_instance ADD COLUMN transition_execution_time Bigint(20) DEFAULT NULL AFTER transition_end;
ALTER TABLE process_instance ADD COLUMN  executiontime Bigint(20) DEFAULT NULL AFTER enddate;

/* -- Ricalcola tempi di esecuzione */
UPDATE process_instance
SET executiontime = TIMESTAMPDIFF(SECOND,startdate,enddate) * 1000;

/* -- Changes for Deploy Tool */
ALTER TABLE attribute ADD CONSTRAINT UNIQUE name (name);

/* --Preference Query */
Create table search_query (
   id_query Bigint(20) NOT NULL AUTO_INCREMENT,
   label Varchar(100) NOT NULL UNIQUE,
   query Text NOT NULL,
Primary Key (id_query));

/* -- Differences with Spagic 2.3.0 -- */

ALTER TABLE process_instance DROP INDEX idx_correlation_id,
 ADD INDEX idx_process_instance_01 (id_correlation);
/* Cannot be unique due to restarted instances */
Create Index idx_transition_instance_01 ON transition_instance (id_message);
Create Index idx_wait_data_01 ON wait_data (id_correlation);
Create Index idx_log_journal_01 ON log_journal (id_journal);
Create Index idx_log_journal_02 ON log_journal (id_state);

/* -- Differences with Spagic 2.4.0 -- */

ALTER TABLE process_instance ADD COLUMN id_parent_process_instance Bigint(20) DEFAULT NULL AFTER id_process_instance;
ALTER TABLE process_instance add Foreign Key (id_parent_process_instance) references process_instance (id_process_instance) on delete  restrict on update  restrict;

/* -- https://spago.eng.it/jira/browse/SPAGIC-366 */
ALTER TABLE process_diagram MODIFY COLUMN svg_diag Mediumtext DEFAULT NULL;

Create table sub_process (
	id_process Bigint NOT NULL,
	id_subprocess Bigint NOT NULL,
	descr Varchar(50),
 Primary Key (id_process,id_subprocess)) ENGINE = InnoDB;

ALTER TABLE sub_process add Foreign Key (id_process) references process (id_process) on delete  restrict on update  restrict;
ALTER TABLE sub_process add Foreign Key (id_subprocess) references process (id_process) on delete  restrict on update  restrict;

INSERT INTO type_service (id_ts, value) VALUES(6, 'JBPM-PROCESS');

INSERT INTO transition_state (id_state,state_value) VALUES(21, 'JBPM_START_ACTIVITY');
INSERT INTO transition_state (id_state,state_value) VALUES(22, 'JBPM_END_ACTIVITY');
INSERT INTO transition_state (id_state,state_value) VALUES(23, 'JBPM_FAULTED_ACTIVITY');

ALTER TABLE process_instance ADD COLUMN id_process_execution_state Bigint(20) NOT NULL DEFAULT 0 AFTER id_pool;
ALTER TABLE process ADD COLUMN id_monitoring_type Bigint(20) NOT NULL DEFAULT 0 AFTER monitor_enabled;

Create table process_execution_state (
	id_process_execution_state Bigint NOT NULL,
	state_value Varchar(100),
 Primary Key (id_process_execution_state)) ENGINE = InnoDB;

Create table monitoring_type (
	id_monitoring_type Bigint NOT NULL,
	type_value Varchar(100),
 Primary Key (id_monitoring_type)) ENGINE = InnoDB;

INSERT INTO pool_type (id_pool_type,id_rule_det_pool_type,name,description,pool_type_version) VALUES(NULL,NULL,'ANONYMOUS','POOL TYPE FOR DYNAMIC LINKS','0');

INSERT INTO process_execution_state (id_process_execution_state,state_value) VALUES(0, 'NORMAL_EXECUTION');
INSERT INTO process_execution_state (id_process_execution_state,state_value) VALUES(1, 'PAUSE_EXECUTION');
INSERT INTO process_execution_state (id_process_execution_state,state_value) VALUES(2, 'STOP_EXECUTION');

INSERT INTO monitoring_type (id_monitoring_type,type_value) VALUES(0, 'ASYNCHRONOUS');
INSERT INTO monitoring_type (id_monitoring_type,type_value) VALUES(1, 'SYNCHRONOUS');

ALTER table process_instance add Foreign Key (id_process_execution_state) references process_execution_state (id_process_execution_state) on delete  restrict on update  restrict;
ALTER table process add Foreign Key (id_monitoring_type) references monitoring_type (id_monitoring_type) on delete  restrict on update  restrict;

/* -- FLAG CONDITIONAL EXIT */
ALTER TABLE step ADD COLUMN has_conditional_exit Bool DEFAULT FALSE;
    
/* Transition_data as CLOB in Transition Instance */
/* Old data in the columns transition_data and transition_data_out */
/* won't be valid anymore */
ALTER TABLE transition_instance MODIFY transition_data Text;
ALTER TABLE transition_instance MODIFY transition_data_out Text;

ALTER TABLE transition_instance MODIFY ID_EXT_PROCESS_INSTANCE Bigint(20);

/* 
-- 2.5.0 performance improvement in backup
*/
Create table temporary_process_instance (
	id_process_instance Bigint(20) NOT NULL,
 Primary Key (id_process_instance)) ENGINE = InnoDB
ROW_FORMAT = Compact;

alter table transition_instance add column runtime_warning BOOLEAN NOT NULL DEFAULT false AFTER attachment_out;