-- Differences with Spagic 2.4.0 --

ALTER TABLE process_instance ADD ( id_parent_process_instance Integer DEFAULT NULL );
ALTER TABLE process_instance ADD ( id_process_execution_state Integer Default 0 NOT NULL );

ALTER TABLE transition_instance MODIFY transition_data CLOB;
ALTER TABLE transition_instance MODIFY transition_data_out CLOB;
ALTER TABLE transition_instance MODIFY ID_EXT_PROCESS_INSTANCE Integer;
ALTER TABLE transition_instance ADD (runtime_warning Char(1) DEFAULT 0);

CREATE VIEW main_relevant_data_process AS 
	SELECT r.id_process_instance, r.id_relevant_data, i.id_parent_process_instance
	FROM spagic.relevant_data_process_instance r, spagic.process_instance i
	WHERE r.id_process_instance = i.id_process_instance;

CREATE VIEW main_relevant_data AS 
	SELECT r.id_relevant_data, r.id_attribute, r.id_log, r.value, j.id_process_instance 
	FROM spagic.relevant_data r, spagic.log_journal l, spagic.transition_instance j, spagic.process_instance i 
	WHERE r.id_log=l.id_log 
	AND l.id_journal=j.id_journal 
	AND j.id_process_instance=i.id_process_instance; 

CREATE VIEW main_log_journal AS 
	SELECT l.id_log, l.id_state, l.id_journal, l.name, l.log, l.datelog, i.id_process_instance
	FROM spagic.log_journal l, spagic.transition_instance j, spagic.process_instance i 
	WHERE l.id_journal=j.id_journal 
	AND j.id_process_instance=i.id_process_instance;

CREATE VIEW main_transition_instance AS 
	SELECT j.id_journal, j.id_step_source, j.id_step_target, j.id_process_instance, j.id_message, j.transition_start, j.transition_end, j.id_ext_process_instance, j.id_state, j.transition_data 
	FROM  spagic.transition_instance j, spagic.process_instance i 
	WHERE j.id_process_instance=i.id_process_instance;

CREATE VIEW main_process_instance AS 
	SELECT i.id_process_instance, i.id_process, i.startdate, i.enddate, i.state, i.id_correlation, i.id_pool , id_parent_process_instance, id_process_execution_state
	FROM spagic.process_instance i;

CREATE VIEW main_pool_instance AS 
	SELECT i.id_pool, i.id_pool_type, i.unique_pool_instance_key 
	FROM spagic.pool_instance i;

CREATE VIEW main_temporary_process AS 
	SELECT id_process_instance FROM spagic.temporary_process_instance;
